package com.eftpay.payplugin.eft_payplugin.alipay;

import android.text.TextUtils;

import org.json.JSONObject;

import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Map;

public class PayResponse {
	
	/***
	 * 	
	 * 
	 * 9000	订单支付成功
	 * 8000	正在处理中，支付结果未知（有可能已经支付成功），请查询商户订单列表中订单的支付状态 .(支付宝服务端返回的错误码)
	 * 4000	订单支付失败
	 * 6001	用户中途取消
	 * 6002	网络连接出错
	 * 6004	支付结果未知（有可能已经支付成功），请查询商户订单列表中订单的支付状态 。（支付宝客户端不能得到服务端的响应，往往是因为网络原因）
	 * 其它支付错误
	 */

	private String resultStatus;
	private String result;
	private String memo;
	
	
	public String trade_no;
	public Map map;

	public PayResponse(String rawResult) {

		if (TextUtils.isEmpty(rawResult))
			return;

		String[] resultParams = rawResult.split(";");
		for (String resultParam : resultParams) {
			if (resultParam.startsWith("resultStatus")) {
				resultStatus = gatValue(resultParam, "resultStatus");
			}
			if (resultParam.startsWith("result")) {
				result = gatValue(resultParam, "result");
			}
			if (resultParam.startsWith("memo")) {
				memo = gatValue(resultParam, "memo");
			}
		}
	}

	@Override
	public String toString() {
		return "resultStatus={" + resultStatus + "};memo={" + memo
				+ "};result={" + result + "}";
	}

	private String gatValue(String content, String key) {
		String prefix = key + "={";
		return content.substring(content.indexOf(prefix) + prefix.length(),
				content.lastIndexOf("}"));
	}

	/**
	 * @return the resultStatus
	 */
	public String getResultStatus() {
		return resultStatus;
	}

	/**
	 * @return the memo
	 */
	public String getMemo() {
		return memo;
	}

	/**
	 * @return the result
	 */
	public String getResult() {
		return result;
	}
	public String getJsonStr(){
		JSONObject jsonObject = new JSONObject();
		try {
			jsonObject.put("return_status",""+resultStatus);
			jsonObject.put("des",""+result);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return jsonObject.toString();
	}
	public Map getMap(){
		Map<String,String> map = new HashMap<>();
		try {
			map.put("return_status",""+resultStatus);
			map.put("des",""+result);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return map;
	}
	public PayResponse(String status,String result){
		this.resultStatus = status;
		this.result = result;
	}
	public PayResponse(JSONObject jsonObject){
		try {
			map = new HashMap();
			Iterator<String> iterator = jsonObject.keys();
			while (iterator.hasNext()){
				String key = iterator.next();
				map.put(key,jsonObject.getString(key));
			}
		}catch (Exception e){

		}

	}
	public Map getQueryResult(){
		if(map!=null){
			return map;
		}else {
			return getMap();
		}

	}
}
