//
//  NSDictionary+GetString.m
//  Income


#import "NSDictionary+GetString.h"




@implementation NSDictionary (GetString)

-(NSString *)getSign:(NSString*)signKey {
  NSArray *sortArray = [self.allKeys sortedArrayUsingComparator:^NSComparisonResult(id  _Nonnull obj1, id  _Nonnull obj2) {
    return [obj1 compare:obj2] == NSOrderedDescending;
  }];
  NSMutableArray *keyArray = [NSMutableArray array];
  for (NSString *key in sortArray) {
    [keyArray addObject:[NSString stringWithFormat:@"%@=%@",key,[self valueForKey:key]]];//兼容nsnumber
  }
  NSString *sign = [signKey stringByAppendingString:[keyArray componentsJoinedByString:@"&"]];
  NSLog(@"sign = %@",sign);
  return sign;
}


-(BOOL)isSign:(NSString*)signKey {
  NSMutableDictionary* copy = [self mutableCopy];
  NSString* sign = [copy objectForKey:@"sign"];
  if(sign==nil){
    return NO;
  }
  [copy removeObjectForKey:@"sign"];
  NSString* localSign = [[copy getSign:signKey] SHA256];
  if(localSign!=nil&&[sign isEqualToString:localSign]){
    return YES;
  }
  
  return NO;
}


//当json存在数组时采用此方式签名
-(NSString *)getSign2:(NSString*)signKey {
  NSArray *sortArray = [self.allKeys sortedArrayUsingComparator:^NSComparisonResult(id  _Nonnull obj1, id  _Nonnull obj2) {
    return [obj1 compare:obj2] == NSOrderedDescending;
  }];
  NSMutableArray *keyArray = [NSMutableArray array];
  for (NSString *key in sortArray) {
    NSObject* value = [self objectForKey:key];
    if([value isKindOfClass:[NSArray class]]||[value isKindOfClass:[NSMutableArray class]]){
      NSArray* array = (NSArray*)value;
      
      NSMutableString* ddd = [[NSMutableString alloc] init];
      
      [ddd appendString:@"["];
      if(array!=nil&&[array count]>0){
        [ddd appendString:@"\""];
        [ddd appendString:[array objectAtIndex:0]];
        [ddd appendString:@"\""];
        for(int i=1;i<[array count];i++){
          [ddd appendString:@","];
          [ddd appendString:@"\""];
          [ddd appendString:[array objectAtIndex:i]];
          [ddd appendString:@"\""];
        }
      }
      [ddd appendString:@"]"];
      [keyArray addObject:[NSString stringWithFormat:@"%@=%@",key,ddd]];
      
    }else if([value isKindOfClass:[NSString class]]){
      [keyArray addObject:[NSString stringWithFormat:@"%@=%@",key,value]];//兼容nsnumber
    }
    
    
  }
  NSString *sign = [signKey stringByAppendingString:[keyArray componentsJoinedByString:@"&"]];
  NSLog(@"sign = %@",sign);
  return sign;
}
-(BOOL)isSign2:(NSString*)signKey {
  NSMutableDictionary* copy = [self mutableCopy];
  NSString* sign = [copy objectForKey:@"sign"];
  if(sign==nil){
    return NO;
  }
  [copy removeObjectForKey:@"sign"];
  NSString* localSign = [[copy getSign2:signKey] SHA256];
  if(localSign!=nil&&[sign isEqualToString:localSign]){
    return YES;
  }
  
  return NO;
}



//当json内嵌JSON对象时采用此方式签名
-(NSString *)getSign:(NSString*)signKey str:(NSString*)str{
  NSArray *sortArray = [self.allKeys sortedArrayUsingComparator:^NSComparisonResult(id  _Nonnull obj1, id  _Nonnull obj2) {
    return [obj1 compare:obj2] == NSOrderedDescending;
  }];
  NSMutableArray *keyArray = [NSMutableArray array];
  for (NSString *key in sortArray) {
    NSObject* value = [self objectForKey:key];
    if([@"pay_apptrade" isEqualToString:key]&&([value isKindOfClass:[NSDictionary class]]||[value isKindOfClass:[NSMutableDictionary class]])){
      NSString* ccc = [str substringToIndex:str.length-1];
      NSRange rang1 = [ccc rangeOfString:@"\"pay_apptrade\":"];
      NSRange rang2 = [ccc rangeOfString:@"}"];
      NSString* ddd = [ccc substringWithRange:NSMakeRange(rang1.location+rang1.length, rang2.location+rang2.length-rang1.location-rang1.length) ];
    
      [keyArray addObject:[NSString stringWithFormat:@"%@=%@",key,ddd]];
      
    }else if([value isKindOfClass:[NSString class]]){
      [keyArray addObject:[NSString stringWithFormat:@"%@=%@",key,value]];//兼容nsnumber
    }
    
    
  }
  NSString *sign = [signKey stringByAppendingString:[keyArray componentsJoinedByString:@"&"]];
  NSLog(@"sign = %@",sign);
  return sign;
}
-(BOOL)isSign:(NSString*)signKey str:(NSString*)str{
  NSMutableDictionary* copy = [self mutableCopy];
  NSString* sign = [copy objectForKey:@"sign"];
  if(sign==nil){
    return NO;
  }
  [copy removeObjectForKey:@"sign"];
  NSString* localSign = [[copy getSign:signKey str:str] SHA256];
  if(localSign!=nil&&[sign isEqualToString:localSign]){
    return YES;
  }
  
  return NO;
}
-(BOOL)isAlipayOrderSign:(NSString*)signKey{
  return [self isSign:signKey];
}
-(BOOL)isWechatOrderSign:(NSString*)signKey str:(NSString*)str{
  return [self isSign:signKey str:str];
}
@end
