//
//  NSJSONSerialization+Json.m
//  Income


#import "NSJSONSerialization+Json.h"

@implementation NSJSONSerialization (Json)
#pragma mark- data-->obj
+(NSDictionary *)getJsonDictionaryWith:(NSString *)jsonString {
  if (!jsonString) {
    return nil;
  }
  NSError *error;
  NSDictionary *json = [NSJSONSerialization JSONObjectWithData:[jsonString dataUsingEncoding:NSUTF8StringEncoding] options:(NSJSONReadingMutableContainers) error:&error];
  if (error) {
    return nil;
  }
  return json;
}

#pragma mark- obj-->data
+(NSData *)getJsonDataWithObject:(id)object {
    NSError *error = nil;
    NSData *data = [NSJSONSerialization dataWithJSONObject:object options:NSJSONWritingPrettyPrinted error:&error];//返回UTF-8
    if (error) {
        return nil;
    }
    return data;
}
+(NSString *)getJsonStrWithObject:(id)object {
  NSData* jsonData = [NSJSONSerialization getJsonDataWithObject:object];
  return [[NSString alloc] initWithData:jsonData encoding:NSUTF8StringEncoding];
}

@end
