//
//  NetWorkServer.m
//  ITS支付
//
//  Created by eft user on 2018/5/16.
//  Copyright © 2018年 Eftsolution. All rights reserved.
//

#import "NetWorkServer.h"


static NetWorkServer* server;
@implementation NetWorkServer

+(NetWorkServer*)getInstance{
  if(server==nil){
    server = [[NetWorkServer alloc]init];
  }
  return server;
}
+ (NSString*) postWithURL:(NSString*)_url params:(NSMutableDictionary*)_params callBack:(void(^)(NSError* _Nullable error,NSString* _Nullable data))callBack {
  NSLog(@"url-->%@",_url);
  NSLog(@"params-->%@",_params);
  return [[NetWorkServer getInstance] doPostWithURL:_url params:_params callBack:callBack];
}

- (NSString*) doPostWithURL:(NSString*)_url params:(NSMutableDictionary*)_params callBack:(void(^)(NSError* _Nullable error,NSString* _Nullable data))callBack{
  
  [self releaseRes];
  
  //对请求路径的说明
  //协议头+主机地址+接口名称
  //POST请求需要修改请求方法为POST，并把参数转换为二进制数据设置为请求体
  
  //1.创建会话对象
  //  NSURLSession *session=[NSURLSession sharedSession];
  
  NSURLSessionConfiguration* config = [NSURLSessionConfiguration defaultSessionConfiguration];
  NSURLSession *session = [NSURLSession sessionWithConfiguration:config delegate:self delegateQueue:[NSOperationQueue mainQueue]];
  
  //2.根据会话对象创建task
  NSURL *url=[NSURL URLWithString:_url];
  
  //3.创建可变的请求对象
  NSMutableURLRequest *request=[NSMutableURLRequest requestWithURL:url];
  
  //4.修改请求方法为POST
  request.HTTPMethod = @"POST";
  
  
  
  
  
  NSString* parames = [NSJSONSerialization getJsonStrWithObject:_params];

  NSLog(@"request json-->%@",parames);

  //5.设置请求体
  request.HTTPBody = [parames dataUsingEncoding:NSUTF8StringEncoding];
  [request setValue:@"application/json;charset=utf8" forHTTPHeaderField:@"Content-Type"];
  [request setTimeoutInterval:TIME_OUT];
  //6.根据会话对象创建一个Task(发送请求）
  /*
    第一个参数：请求对象
    第二个参数：completionHandler回调（请求完成【成功|失败】的回调）
    data：响应体信息（期望的数据）
    response：响应头信息，主要是对服务器端的描述
    error：错误信息，如果请求失败，则error有值
    */
  NSString* key = [self createKey];
  NSLog(@"key = %@",key);

  NSURLSessionDataTask* _task =[session dataTaskWithRequest:request completionHandler:^(NSData* _Nullable data,NSURLResponse* _Nullable response,NSError* _Nullable error){
    
    @try {
      // 可能会出现崩溃的代码
      if(data!=nil){
        NSString* result = [[NSString alloc]initWithData:data encoding:NSUTF8StringEncoding];
        
        NSLog(@"result = %@", result);
        // 结果处理
        if(callBack!=nil){
          callBack(error,result);
        }
        
      }else{
        if(callBack!=nil){
          callBack(nil,nil);
        }
        
      }
      
    }
    @catch (NSException *exception) {
      // 捕获到的异常exception
      if(callBack!=nil){
        callBack(nil,nil);
      }
      
    }
    @finally {
      // 释放资源
      [self releaseRes:key];
    }
    
    

    
    //8.解析数据
    //NSDictionary *dict = [NSJSONSerialization JSONObjectWithData:data options:kNilOptions error:nil];
    //NSLog(@"%@",dict);
    
    
    
  }];
  if(arrayTask==nil){
    arrayTask = [[NSMutableArray alloc] init];
  }
  [arrayTask addObject:key];
  if(dicTask==nil){
    dicTask = [[NSMutableDictionary alloc] init];
  }
  [dicTask setObject:_task forKey:key];
  //7.执行任务
  [_task resume];
  return  key;
}



- (NSString*) doPostWithURL2:(NSString*)_url params:(NSMutableDictionary*)_params callBack:(void(^)(NSError* _Nullable error,NSString* _Nullable data))callBack{
  
  [self releaseRes];
  
  //对请求路径的说明
  //协议头+主机地址+接口名称
  //POST请求需要修改请求方法为POST，并把参数转换为二进制数据设置为请求体
  
  //1.创建会话对象
  //  NSURLSession *session=[NSURLSession sharedSession];
  
  NSURLSessionConfiguration* config = [NSURLSessionConfiguration backgroundSessionConfigurationWithIdentifier:@"com.eftsolution.EFT-Wechat-ITS-2.BackgroundSession"];

  
  NSURLSession *session = [NSURLSession sessionWithConfiguration:config delegate:self delegateQueue:[NSOperationQueue mainQueue]];
  
  //2.根据会话对象创建task
  NSURL *url=[NSURL URLWithString:_url];
  
  //3.创建可变的请求对象
  NSMutableURLRequest *request=[NSMutableURLRequest requestWithURL:url];
  
  //4.修改请求方法为POST
  request.HTTPMethod = @"POST";
  
  
  
  
  NSString* parames = [NSJSONSerialization getJsonStrWithObject:_params];
  
  NSLog(@"request json-->%@",parames);
  
  //5.设置请求体
  request.HTTPBody = [parames dataUsingEncoding:NSUTF8StringEncoding];
  [request setValue:@"application/json;charset=utf8" forHTTPHeaderField:@"Content-Type"];
  [request setTimeoutInterval:TIME_OUT];
  //6.根据会话对象创建一个Task(发送请求）
  /*
    第一个参数：请求对象
    第二个参数：completionHandler回调（请求完成【成功|失败】的回调）
    data：响应体信息（期望的数据）
    response：响应头信息，主要是对服务器端的描述
    error：错误信息，如果请求失败，则error有值
    */
  NSString* key = [self createKey];
  NSLog(@"key = %@",key);
  
  NSURLSessionDataTask* _task = [session dataTaskWithRequest:request];
  
  if(arrayTask==nil){
    arrayTask = [[NSMutableArray alloc] init];
  }
  [arrayTask addObject:key];
  if(dicTask==nil){
    dicTask = [[NSMutableDictionary alloc] init];
  }
  [dicTask setObject:_task forKey:key];
  //7.执行任务
  [_task resume];
  return  key;
}












-(void)URLSession:(NSURLSession *)session didReceiveChallenge:(NSURLAuthenticationChallenge *)challenge completionHandler:(void (^)(NSURLSessionAuthChallengeDisposition, NSURLCredential *))completionHandler
{
  //判断服务器返回的证书类型, 是否是服务器信任....判断https,还是要开ATS才能请求(可能因为没有SSL证书)
  if ([challenge.protectionSpace.authenticationMethod isEqualToString:NSURLAuthenticationMethodServerTrust]) {
    
    NSURLCredential *card = [[NSURLCredential alloc]initWithTrust:challenge.protectionSpace.serverTrust];
    completionHandler(NSURLSessionAuthChallengeUseCredential , card);
  }
}



-(void) releaseRes {
  if(arrayTask!=nil){
    NSLog(@"crrrecy task counts = %lu",(unsigned long)arrayTask.count);
    while(arrayTask.count>MAX_NET_THRED_COUNT){
      //
      NSLog(@"crrrecy task counts = %lu",(unsigned long)arrayTask.count);
      NSString* key = [arrayTask firstObject];
      if(key!=nil){
        [self releaseRes:key];
      }
      
    }
  }
  
}

-(void) releaseRes:(NSString*)key {
  if(arrayTask!=nil){
    [arrayTask removeObject:key];
  }
  if(dicTask!=nil){
    NSURLSessionDataTask* _task  = [dicTask objectForKey:key];
    [dicTask removeObjectForKey:key];
    if(_task!=nil){
      [_task cancel];
      _task = nil;
    }
  }
}

+(void) closeKey:(NSString*)key {
    if(server!=nil){
        [server releaseRes:key];
    }
}
+(void)close {
    if(server!=nil){
        [server closeTask];
    }
}

-(void) closeTask {
  if(arrayTask!=nil){
    [arrayTask removeAllObjects];
    arrayTask = nil;
  }
  if(dicTask!=nil){
    NSArray* array = [dicTask allKeys];
    for(NSString* key in array){
      NSURLSessionDataTask* _task  = [dicTask objectForKey:key];
      if(_task!=nil){
        [_task cancel];
        _task = nil;
      }
    }
    [dicTask removeAllObjects];
  }
}
-(NSString*)createKey {
  NSDate* dat = [NSDate dateWithTimeIntervalSinceNow:0];
  NSTimeInterval a=[dat timeIntervalSince1970]*1000;
  NSString *timeString = [NSString stringWithFormat:@"%f", a];
  int y = arc4random() % 10001 ;
  return [timeString stringByAppendingString:[NSString stringWithFormat:@"%05i",y]];
}


@end
