//
//  PayUtil.h
//  ltxgtpay
//
//  Created by eft user on 2019/3/7.
//  Copyright © 2019年 Eftsolution. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <AlipaySDK/AlipaySDK.h>
#import "WXApi.h"
#import "WXApiObject.h"
#import "NSDate+GetTime.h"

#define ALIPAYCN 1
#define ALIPAYHK 2
#define WECHATCN 3
#define WECHATHK 4

NS_ASSUME_NONNULL_BEGIN



@interface PayUtil : NSObject

/**
 payType:支付类型ALIPAYCN ALIPAYHK WECHATCN WECHATHK
 url:后台下单服务器路径
 userKey:后台分配的userKey,用于区分商户
 signKey:后台分配的signKey,用于验证签名
 outTradeNo:商户自定义,20位长度唯一字符串,建议14位时间戳+6位随机数
 price:支付金额
 currency:货币类型,固定HKD
 subject:由商户自定义
 body:由商户自定义
 finish:回调函数
    isError=YES:网络错误或服务器错误,服务器错误详情在dic中"return_status"描述错误代码,"return_char"描述错误原因
    isSign=NO:签名错误
    dic:下单返回值,调起支付时用到(dic字段说明参考SDK说明文档)
 */
+ (void)pay:(int)payType url:(NSString*)url userKey:(NSString*)userKey signKey:(NSString*)signKey outTradeNo:(NSString*)outTradeNo price:(double)price currency:(NSString*)currency subject:(NSString*)subject body:(NSString*)body finish:(void(^_Nullable)(BOOL isError,BOOL isSign,NSDictionary* _Nullable dic))finish;
/**
 payType:支付类型ALIPAYCN ALIPAYHK WECHATCN WECHATHK
 url:后台查询服务器路径
 userKey:后台分配的userKey,用于区分商户,需和下单一致
 signKey:后台分配的signKey,用于验证签名,需和下单一致
 outTradeNo:下单是商户自定义的
 finish:回调函数
 isError=YES:网络错误或服务器错误,服务器错误详情在dic中"return_status"描述错误代码,"return_char"描述错误原因
 isSign=NO:签名错误
 dic:下单返回值,调起支付时用到(dic字段说明参考SDK说明文档)
 */
+(void)query:(NSString*)payType url:(NSString*)url userKey:(NSString*)userKey signKey:(NSString*)signKey outTradeNo:(NSString*)outTradeNo finish:(void(^_Nullable)(BOOL isError,BOOL isSign,NSDictionary* _Nullable dic))finish;
+(void)query:(NSMutableDictionary*)requestDic finish:(void(^_Nullable)(BOOL isError,BOOL isSign,NSDictionary* _Nullable dic))finish;
+ (void)pay:(NSMutableDictionary*)dic finish:(void(^_Nullable)(BOOL isError,BOOL isSign,NSDictionary* _Nullable dic))finish;

@end

NS_ASSUME_NONNULL_END
